// Code generated by protoc-gen-defaults. DO NOT EDIT.

package bookpb

import "context"

import "github.com/golang/protobuf/ptypes/empty"
import "go.uber.org/fx"
import "go.appointy.com/events/example/pb/events"

import "go.appointy.com/waqt/protos/users"

type NotificationEvent string

const ()

/*
	Receiving usage :

	switch (NotificationEvent(event.EventType)){






	        }
*/

type EventsBooksServer struct {
	BooksServer
	eventsCli events.EventValidatorsClient
	user      users.UserIDer
}

type EventsBooksClientResult struct {
	fx.Out
	BooksClient BooksClient `name:"r"`
}

func NewEventsBooksClient(c events.EventValidatorsClient, s BooksServer, u users.UserIDer) EventsBooksClientResult {
	return EventsBooksClientResult{BooksClient: NewLocalBooksClient(NewEventsBooksServer(c, s, u))}
}
func NewEventsBooksServer(c events.EventValidatorsClient, s BooksServer, u users.UserIDer) BooksServer {
	return &EventsBooksServer{
		s,
		c,
		u,
	}
}

func (s *EventsBooksServer) CreateBook(ctx context.Context, eventsvar *CreateBookRequest) (*Book, error) {

	res, err := s.BooksServer.CreateBook(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}

func (s *EventsBooksServer) GetBook(ctx context.Context, eventsvar *GetBookRequest) (*Book, error) {

	res, err := s.BooksServer.GetBook(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}

func (s *EventsBooksServer) UpdateBook(ctx context.Context, eventsvar *UpdateBookRequest) (*empty.Empty, error) {

	res, err := s.BooksServer.UpdateBook(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}

func (s *EventsBooksServer) DeleteBook(ctx context.Context, eventsvar *DeleteBookRequest) (*empty.Empty, error) {

	res, err := s.BooksServer.DeleteBook(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}

func (s *EventsBooksServer) ListBook(ctx context.Context, eventsvar *ListBookRequest) (*ListBookResponse, error) {

	res, err := s.BooksServer.ListBook(ctx, eventsvar)
	if err != nil {
		return nil, err
	}

	return res, nil

}
